// Bid2Asp
// Created by Steven Lawrance
// Converts your bid files into Procomm Plus for DOS ASP format.

#include <windowsx.h>
#include <string.h>
#include <commdlg.h>
#include <stdio.h>
#include <256color.h>

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void WMCommand_Handler(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
BOOL CALLBACK _export ImportDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void WMImportDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);
//BOOL CALLBACK _export HeaderDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
//void WMHeaderDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);
BOOL CALLBACK _export WorkingDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void WMWorkingDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);

char *ReadToEndOfLine(HFILE hFile);
char *GetFile(char *DialogText, char *DefaultText, char *FileString, DWORD MustExist);
void WriteToFile(FILE *hFile, char *Text);
void StatusLine(HWND hDlg, char *Information, char *Percent);

DWORD CompileYN;
HMENU hMenu;
HINSTANCE ghInstance;
HWND ghWnd;
HFILE hInFile;
FILE *hOutFile;
HBITMAP hBitmap;
HPALETTE hPalette;
int NumLines;
char InputFile[144];
char OutputFile[144];
char CompileFile[144];

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdParam, int nCmdShow)
{
   HWND        hWnd;
   MSG         msg;
   char TmpStr[6];

   ghInstance = hInstance;
   if (!hPrevInstance)
   {
      WNDCLASS    wndclass;

      wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS | CS_GLOBALCLASS |CS_BYTEALIGNWINDOW;
      wndclass.lpfnWndProc   = (WNDPROC) MainWndProc;
      wndclass.hInstance     = hInstance;
      wndclass.hIcon         = LoadIcon (wndclass.hInstance, "bids");
      wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      wndclass.lpszMenuName  = "MAIN";
      wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
      wndclass.lpszMenuName  = NULL;
      wndclass.cbClsExtra    = 0;
      wndclass.cbWndExtra    = 0;
      wndclass.lpszClassName = "BID2ASP";

      RegisterClass(&wndclass);
   }

   hWnd = CreateWindow("BID2ASP", "Bids To ASP for Windows",
		       WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX,
                       CW_USEDEFAULT, CW_USEDEFAULT,          
		       322, 240,
                       NULL, NULL, hInstance, NULL);

   if (hPrevInstance)
   {
      MessageBox(NULL, "Bids To ASP is already running!", "Bids To ASP Warning", MB_OK | MB_ICONEXCLAMATION);
      DestroyWindow(hWnd);
   }
   hMenu = LoadMenu(ghInstance, "MAIN");
   SetMenu(hWnd, hMenu);
   GetPrivateProfileString("Compile", "CompileYN", "", TmpStr, 6, "BIDS.INI");
   if (strcmp(TmpStr, "TRUE") == 0)
   {
     CompileYN = TRUE;
     CheckMenuItem(hMenu, 103, MF_CHECKED);
   }
   else
   {
     CompileYN = FALSE;
     CheckMenuItem(hMenu, 103, MF_UNCHECKED);
   }
   if (strcmp(lpCmdParam, "!") == 0)
   {
      DLGPROC AbtDlgProc;
      DWORD StopNow = FALSE;
      if (strcmp(InputFile, "") == 0)
	StopNow = TRUE;
      if (strcmp(OutputFile, "") == 0)
	StopNow = TRUE;
      if (strcmp(CompileFile, "") == 0)
	StopNow = TRUE;
      if (StopNow == TRUE)
      {
        MessageBox(hWnd, "Program Not Fully Configured.  Please Adjust Settings Or Import A SendBid 1.0 File If You Have SendBid 1.0 For DOS.", "Settings Error", MB_OK | MB_ICONSTOP);
      }
      else
      {
	AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)WorkingDlgProc, ghInstance);
	DialogBox(ghInstance, "WORKING", NULL, AbtDlgProc);
        FreeProcInstance((FARPROC)AbtDlgProc);
      }
      DestroyWindow(hWnd);
      goto End;
   }
   hBitmap = GetPic256(hWnd, "BID2ASP");
   hPalette = GetPicPal();
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   while (GetMessage(&msg, NULL, 0, 0))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
   End:
   return msg.wParam;
}

#pragma argsused
LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam)
{
   switch (message)
   {
      case WM_CREATE :
      {
	ghWnd = hWnd;
        GetPrivateProfileString("FilePaths", "InputFile", "", InputFile, 144, "BIDS.INI");
	GetPrivateProfileString("FilePaths", "OutputFile", "", OutputFile, 144, "BIDS.INI");
	GetPrivateProfileString("Compile", "CompileFile", "", CompileFile, 144, "BIDS.INI");
	return 0;
      }
      case WM_SETFOCUS :
      {
        RefreshPicPal(hWnd, hPalette);
      }
      case WM_PAINT :
      case WM_ERASEBKGND :
      {
	RefreshPicture(hWnd, hBitmap, hPalette, 0, 0, 0, 0, 0, 0);
	return 1;
      }
      case WM_DESTROY :
      {
	DeletePic(hBitmap);
	DeletePal(hPalette);
	DeleteObject(hBitmap);
        DeleteObject(hPalette);
	PostQuitMessage(0);
        return 0;
      }
      case WM_COMMAND :
      {
	 return HANDLE_WM_COMMAND(hWnd, wParam, lParam, WMCommand_Handler);
      }
   }
   return DefWindowProc (hWnd, message, wParam, lParam);
}

#pragma argsused
void WMCommand_Handler(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify)
{
  switch (id)
  {
    case 101:
    {
      strcpy(InputFile, GetFile("Input File", InputFile, "Text Files\0*.txt;*.wri;*.wps;*.doc\0All Files\0*.*\0\0", TRUE));
      WritePrivateProfileString("FilePaths", "InputFile", InputFile, "BIDS.INI");
      break;
    }
    case 102:
    {
      strcpy(OutputFile, GetFile("Output File", OutputFile, "ASP Files\0*.asp\0Text Files\0*.txt;*.wri;*.wps;*.doc\0All Files\0*.*\0\0", FALSE));
      WritePrivateProfileString("FilePaths", "OutputFile", OutputFile, "BIDS.INI");
      break;
    }
    case 103:
    {
      if (GetMenuState(hMenu, 103, MF_BYCOMMAND) == MF_CHECKED)
      {
        CheckMenuItem(hMenu, 103, MF_UNCHECKED);
	WritePrivateProfileString("Compile", "CompileYN", "FALSE", "BIDS.INI");
	CompileYN = FALSE;
      }
      else
      {
	CheckMenuItem(hMenu, 103, MF_CHECKED);
	WritePrivateProfileString("Compile", "CompileYN", "TRUE", "BIDS.INI");
	CompileYN = TRUE;
      }
      break;
    }
    case 104:
    {
      strcpy(CompileFile, GetFile("Compiler Program", CompileFile, "Procomm Plus Compiler\0aspcomp.exe\0Executables\0*.exe;*.pif;*.com\0All Files\0*.*\0\0", TRUE));
      WritePrivateProfileString("Compile", "CompileFile", CompileFile, "BIDS.INI");
      break;
    }
    case 105:
    {
      MessageBox(hWnd, "This program was created by Steven Lawrance.  The pictures and icons were created by Joey Lawrance.  If you have any questions, fell free to contact me at \"steven.lawrance@contrail.com\".  Brought to you by KittyCat! Systems as FREEWARE.  Also be sure to watch for KittyCat! Comm 1.0 for Windows in 1995!  Thank you!", "About", MB_OK);
      break;
    }
    case 106:
    {
      char TmpStr[144];
      DLGPROC AbtDlgProc;
      strcpy(TmpStr, GetFile("Import BIDS.CFG File", "", "SendBid 1.0 for QBASIC\0BIDS.CFG\0\0", TRUE));
      if (strcmp(TmpStr, "") != 0)
      {
        AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)ImportDlgProc, ghInstance);
	DialogBoxParam(ghInstance, "IMPORT", hWnd, AbtDlgProc, (LPARAM) TmpStr);
        FreeProcInstance((FARPROC)AbtDlgProc);
      }
      break;
    }
    case 107:
    {
      DestroyWindow(hWnd);
      break;
    }
    case 108:
    {
      DLGPROC AbtDlgProc;
      DWORD StopNow = FALSE;
      if (strcmp(InputFile, "") == 0)
	StopNow = TRUE;
      if (strcmp(OutputFile, "") == 0)
	StopNow = TRUE;
      if (strcmp(CompileFile, "") == 0)
	StopNow = TRUE;
      if (StopNow == TRUE)
      {
        MessageBox(hWnd, "Program Not Fully Configured.  Please Adjust Settings Or Import A SendBid 1.0 File If You Have SendBid 1.0 For DOS.", "Settings Error", MB_OK | MB_ICONSTOP);
      }
      else
      {
	AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)WorkingDlgProc, ghInstance);
	DialogBox(ghInstance, "WORKING", hWnd, AbtDlgProc);
        FreeProcInstance((FARPROC)AbtDlgProc);
      }
      break;
    }
/*    case 109 :
    {
      DLGPROC AbtDlgProc;
      AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)HeaderDlgProc, ghInstance);
      DialogBox(ghInstance, "HEADER", hWnd, AbtDlgProc);
      FreeProcInstance((FARPROC)AbtDlgProc);
      break;
    }*/
  }
}

char *GetFile(char *DialogText, char *DefaultText, char *FileString, DWORD MustExist)
{
  char WorkStr[144];
  OPENFILENAME ofn;
  char File[144];
  char Dir[144];
  if (strcmp(DefaultText, "") == 0)
  {
    Dir[0] = '\0';
    File[0] = '\0';
    DefaultText[0] = '\0';
  }
  else
  {
    int i, t, s;
    strrev(DefaultText);
    for (i=0;i<=strlen(DefaultText);i++)
    {
      if (DefaultText[i] == '\\')
      {
        t = i+1;
        File[i] = '\0';
	goto GetDir;
      }
      if (DefaultText[i] == ':')
      {
	t = i+1;
	File[i] = '\0';
	goto GetDir;
      }
      else
      {
        File[i] = DefaultText[i];
      }
    }
    GetDir:
    for (s=t;s<=strlen(DefaultText);s++)
    {
      Dir[s-t] = DefaultText[s];
    }
    Dir[strlen(DefaultText)-t] = '\0';
    strrev(Dir);
    strrev(File);
    strrev(DefaultText);
  }
  memset(&ofn, 0, sizeof(OPENFILENAME));
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = ghWnd;
  ofn.lpstrFilter = FileString;
  ofn.lpstrFile = File;
  ofn.nMaxFile = 144;
  ofn.lpstrFileTitle = WorkStr;
  ofn.nMaxFileTitle = 144;
  ofn.lpstrInitialDir = Dir;
  ofn.lpstrDefExt = "bid";
  if (MustExist == TRUE)
  {
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
  }
  else
  {
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
  }
  ofn.lpstrTitle = DialogText; 
  if (!GetOpenFileName(&ofn))
  {
    strcpy(WorkStr, DefaultText);
  }
  else
  {
    strcpy(WorkStr, ofn.lpstrFile);
  }
  return WorkStr;
}

#pragma argused
BOOL CALLBACK _export ImportDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
        HFILE hFile;
        OFSTRUCT os;
        char TmpStr[144];
        memset(&os, 0, sizeof(OFSTRUCT));
	hFile = OpenFile((LPCSTR) lParam, &os, OF_READ);
	strcpy(TmpStr, "Information In ");
	strcat(TmpStr, (LPCSTR) lParam);
        SetDlgItemText(hDlg, 200, TmpStr);
	SetDlgItemText(hDlg, 300, ReadToEndOfLine(hFile));
	SetDlgItemText(hDlg, 301, ReadToEndOfLine(hFile));
	SetDlgItemText(hDlg, 302, ReadToEndOfLine(hFile));
	SetDlgItemText(hDlg, 303, ReadToEndOfLine(hFile));
	SetDlgItemText(hDlg, 304, ReadToEndOfLine(hFile));
	ReadToEndOfLine(hFile);
	strcpy(TmpStr, ReadToEndOfLine(hFile));
	if (strcmp(TmpStr, "compile") == 0)
        {
	  SetDlgItemText(hDlg, 305, "Yes");
        }
	else
        {
	  SetDlgItemText(hDlg, 305, "No");
	}
	SetDlgItemText(hDlg, 307, ReadToEndOfLine(hFile));
	SetDlgItemText(hDlg, 306, ReadToEndOfLine(hFile));
        _lclose(hFile);
	return TRUE;
      }
      case WM_COMMAND :
      {
	return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMImportDlgCommand_Handler);
      }
   }

   return FALSE;
}

#pragma argsused
void WMImportDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
     case 2 :
     {
       MessageBox(hDlg, "Information Not Saved", "Import BIDS.CFG File", MB_OK | MB_ICONASTERISK);
       EndDialog(hDlg, 0);
       break;
     }
     case 1 :
     {
       char WorkStr[144];
       char DirCombine[144];
       char TmpStr[6];
       SetWindowText(hDlg, "Please Wait...");
       EnableWindow(GetDlgItem(hDlg, 1), WS_DISABLED);
       EnableWindow(GetDlgItem(hDlg, 2), WS_DISABLED);
       GetDlgItemText(hDlg, 301, DirCombine, 144);
       strrev(DirCombine);
       if (DirCombine[0] != '\\')
       {
	 strrev(DirCombine);
	 strcat(DirCombine, "\\");
       }
       else
         strrev(DirCombine);
       GetDlgItemText(hDlg, 302, WorkStr, 144);
       strcat(DirCombine, WorkStr);
       WritePrivateProfileString("FilePaths", "InputFile", DirCombine, "BIDS.INI");
       GetDlgItemText(hDlg, 303, DirCombine, 144);
       strrev(DirCombine);
       if (DirCombine[0] != '\\')
       {
	 strrev(DirCombine);
	 strcat(DirCombine, "\\");
       }
       else
         strrev(DirCombine);
       GetDlgItemText(hDlg, 304, WorkStr, 144);
       strcat(DirCombine, WorkStr);
       WritePrivateProfileString("FilePaths", "OutputFile", DirCombine, "BIDS.INI");
       GetDlgItemText(hDlg, 305, WorkStr, 144);
       if (strcmp(WorkStr, "Yes") == 0)
       	 WritePrivateProfileString("Compile", "CompileYN", "TRUE", "BIDS.INI");
       else
	 WritePrivateProfileString("Compile", "CompileYN", "FALSE", "BIDS.INI");
       GetDlgItemText(hDlg, 306, DirCombine, 144);
       strrev(DirCombine);
       if (DirCombine[0] != '\\')
       {
	 strrev(DirCombine);
	 strcat(DirCombine, "\\");
       }
       else
         strrev(DirCombine);
       GetDlgItemText(hDlg, 307, WorkStr, 144);
       strcat(DirCombine, WorkStr);
       WritePrivateProfileString("Compile", "CompileFile", DirCombine, "BIDS.INI");
       GetPrivateProfileString("FilePaths", "InputFile", "", InputFile, 144, "BIDS.INI");
       GetPrivateProfileString("FilePaths", "OutputFile", "", OutputFile, 144, "BIDS.INI");
       GetPrivateProfileString("Compile", "CompileFile", "", CompileFile, 144, "BIDS.INI");
       GetPrivateProfileString("Compile", "CompileYN", "", TmpStr, 6, "BIDS.INI");
       if (strcmp(TmpStr, "TRUE") == 0)
       {
         CompileYN = TRUE;
         CheckMenuItem(hMenu, 103, MF_CHECKED);
       }
       else
       {
         CompileYN = FALSE;
         CheckMenuItem(hMenu, 103, MF_UNCHECKED);
       }
       EndDialog(hDlg, 0);
       break;
     }
   }
}

char *ReadToEndOfLine(HFILE hFile)
{
  char DataTmp[5];
  char WorkStr[300];
  int ReadRes;
  int i = 0;
  memset(WorkStr, NULL, sizeof(WorkStr));
  memset(DataTmp, NULL, sizeof(DataTmp));
  ReadRes = _lread(hFile, DataTmp, 1);
  do
  {
    if (ReadRes < 1)
    {
      strcpy(WorkStr, "  [File Error: The Requested Segment Extends Out Of File!]  ");
      goto End;
    }
    WorkStr[i] = DataTmp[0];
    ReadRes = _lread(hFile, DataTmp, 1);
    i = i + 1;
  } while (DataTmp[0] != '\n');
  WorkStr[i-1] = '\0';
  End:
  return WorkStr;
}

#pragma argused
BOOL CALLBACK _export WorkingDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
        OFSTRUCT os1;
        hInFile = OpenFile(InputFile, &os1, OF_READ); 
	hOutFile = fopen(OutputFile, "w");
	if (hInFile == NULL)
	{
	  fclose(hOutFile);
          MessageBox(hDlg, "Check File Names And Access Levels Before Trying Again.", "File Error", MB_OK | MB_ICONSTOP);
        }
	if (hOutFile == NULL)
	{
	  _lclose(hInFile);
	  MessageBox(hDlg, "Check File Names And Access Levels Before Trying Again.", "File Error", MB_OK | MB_ICONSTOP);
        }
	StatusLine(hDlg, "Writing Header To File...", "This puts a header on the ASP.");
	WriteToFile(hOutFile, "PROC MAIN\n");
	WriteToFile(hOutFile, "TRANSMIT \"5^M\"\n");
	WriteToFile(hOutFile, "WAITFOR \"FOS >\"\n");
	SetTimer(hDlg, 700, 500, NULL);
	return TRUE;
      }
      case WM_TIMER :
      {
        int ReadTo;
        char InText[100];
        char DataTmp[2];
	KillTimer(hDlg, 700);
	ReadTo = _lread(hInFile, DataTmp, 1);
        _llseek(hInFile, -1, 1);
	StatusLine(hDlg, "Converting File...", "This converts input to ASP.");
	do
        {
  	  if (ReadTo < 1)
	  {
	    if (CompileYN == TRUE)
	    {
              char CompStr[288];
	      StatusLine(hDlg, "Compiling...", "This procedure may exit to DOS.");
	      strcpy(CompStr, CompileFile);
	      strcat(CompStr, " ");
	      strcat(CompStr, OutputFile);
	      WinExec(CompStr, SW_SHOWNORMAL);
            }
	    EnableWindow(GetDlgItem(hDlg, 2), WS_DISABLED);
            StatusLine(hDlg, "Adding footer to output file...", "This is the last step.");
	    WriteToFile(hOutFile, "TRANSMIT \"X^M\"\n");
	    WriteToFile(hOutFile, "WAITFOR \"FOS\"\n");
	    WriteToFile(hOutFile, "TRANSMIT \"9^M\"\n");
	    WriteToFile(hOutFile, "WAITFOR \"FOS >\"\n");
	    WriteToFile(hOutFile, "TRANSMIT \"C\"\n");
	    WriteToFile(hOutFile, "ENDPROC\n");
	    fclose(hOutFile);
            _lclose(hInFile);
	    StatusLine(hDlg, "Finished!", "Exiting this window.");
	    goto End;
          }
	  strcpy(InText, "TRANSMIT \"");
	  strcat(InText, ReadToEndOfLine(hInFile));
	  strcat(InText, "^M\"\n");
          WriteToFile(hOutFile, InText);
	  WriteToFile(hOutFile, "WAITFOR \"FOS >\"\n");
	  ReadTo = _lread(hInFile, DataTmp, 1);
          _llseek(hInFile, -1, 1);
	} while (DataTmp[0] != '!');
        End:
        EndDialog(hDlg, 0);
      }
      case WM_COMMAND :
      {
	return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMWorkingDlgCommand_Handler);
      }
   }
   return FALSE;
}

#pragma argsused
void WMWorkingDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
     case 2 :
     {
       if (MessageBox(hDlg, "Are You Sure You Want To Stop?", "Work Interrupted", MB_YESNO | MB_DEFBUTTON2 | MB_ICONQUESTION) == IDYES)
       {
	 _lclose(hInFile);
	 fclose(hOutFile);
	 EndDialog(hDlg, 0);
       }
       break;
     }
   }
}

void WriteToFile(FILE *hFile, char *Text)
{
  fputs(Text, hFile);
}

void StatusLine(HWND hDlg, char *Information, char *Percent)
{
  SetDlgItemText(hDlg, 301, Information);
  SetDlgItemText(hDlg, 302, Percent);
}

/*#pragma argsused
BOOL CALLBACK _export HeaderDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
        OFSTRUCT os;
        hInFile = OpenFile("HDR&FTR.CFG", &os, OF_READWRITE);
	if (hInFile == HFILE_ERROR)
	{
	  hInFile = OpenFile("HDR&FTR.CFG", &os, OF_CREATE);
	  if (hInFile == HFILE_ERROR)
	  {
	    MessageBeep(MB_ICONSTOP);
            MessageBox(hDlg, "Cannot Create Nor Open Header And Footer File!", "File I/O Error", MB_OK | MB_ICONSTOP);
	    SetDlgItemText(hDlg, 300, "Error - File Doesn't Exist");
	    SetDlgItemText(hDlg, 301, "Press [Cancel] Now");
            SetDlgItemText(hDlg, 302, "n/a");
	    SetDlgItemText(hDlg, 303, "n/a");
	    SetDlgItemText(hDlg, 304, "n/a");
            EnableWindow(GetWindow(hDlg, 302), WS_DISABLED);
	    EnableWindow(GetWindow(hDlg, 303), WS_DISABLED);
	    EnableWindow(GetWindow(hDlg, 304), WS_DISABLED);
            goto End;
	  }
	  else
	  {

          }
        }
//	gcvt(NumLines, 10, ReadToEndOfLine(hInFile));
	End:
	return TRUE;
      }
      case WM_COMMAND :
      {
	return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMHeaderDlgCommand_Handler);
      }
   }
   return FALSE;
}

#pragma argsused
void WMHeaderDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
      case 2 :
      {
	 EndDialog(hDlg, 0);
	 break;
      }
   }
}*/
