// Bid2Asp
// Created by Steven Lawrance
// Converts your bid files into Procomm Plus for DOS ASP format.

#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <process.h>
#include <io.h>

#define FALSE 0
#define TRUE  1

long int _llseek(FILE *hFile, long int Bytes, int Position);
long int _lread(FILE *hFile, void *Data, long int Bytes);
void Translate(void);
void Configure(void);
void GetPrivateProfileString(const char *Section, const char *Item, const char *Default, char *Value, const int ValueLen, const char *FileName);
void WritePrivateProfileString(const char *Section, const char *Item, const char *Value, const char *FileName);
char far *ReadToEndOfLine(FILE *hFile);
char far *GetFile(char *DialogText, char *DefaultText, char *FileString, int MustExist);
void WriteToFile(FILE *hFile, char *Text);
void StatusLine(char *Information, char *Percent);
void MessageBox(char *Message, char *Title);

FILE *hInFile;
FILE *hOutFile;
int NumLines;
int CompileYN;
char InputFile[144];
char OutputFile[144];
char CompileFile[144];

void main(int argc, char * argv[])
{
	GetPrivateProfileString("FilePaths", "InputFile", "", InputFile, 144, "BIDS.INI");
	GetPrivateProfileString("FilePaths", "OutputFile", "", OutputFile, 144, "BIDS.INI");
	GetPrivateProfileString("Compile", "CompileFile", "", CompileFile, 144, "BIDS.INI");
	GetPrivateProfileString("Compile", "CompileFile", "", CompileFile, 144, "BIDS.INI");
	if (strcmp(CompileFile, "") == 0)
	  CompileYN = FALSE;
	else
	  CompileYN = TRUE;
	if ((argc > 1) && (strcmp(argv[1], "!")))
	{
	  int StopNow = FALSE;
	  if (strcmp(InputFile, "") == 0)
		 StopNow = TRUE;
	  if (strcmp(OutputFile, "") == 0)
		 StopNow = TRUE;
	  if (strcmp(CompileFile, "") == 0)
		 StopNow = TRUE;
	  if (StopNow == TRUE)
	  {
		 printf("-[Settings Error]-\nProgram Not Fully Configured.  Please Adjust Settings Or Import\n A SendBid 1.0 File If You Have SendBid 1.0 For DOS.\nPress any key to continue... ");
		 getch();
		 printf("\n");
	  }
	  else
		 Translate();
	}
	else
	{
	  int ExitYN = FALSE;
	  do
	  {
		 char Choice;
		 clrscr();
		 printf("Bids To ASP for DOS\nBy Steven Lawrance\n\n");
		 printf("-[Menu]-\n1. Translate");
		 if (CompileYN == TRUE)
			printf(" and Compile");
		 printf(" Bidsheet\n2. Configure\n3. About\n4. Exit\n\nChoice: ");
		 do
		 {
			Choice = getch();
		 } while (((Choice < '1') || (Choice > '4')) && (Choice != 13) && (Choice != 27));
		 if (Choice == 13)
			Choice = '1';
		 if (Choice == 27)
			Choice = '4';
		 printf("%c\n", Choice);
		 switch (Choice)
		 {
			case '1' :
			{
			  int StopNow = FALSE;
			  if (strcmp(InputFile, "") == 0)
				 StopNow = TRUE;
			  if (strcmp(OutputFile, "") == 0)
				 StopNow = TRUE;
			  if (strcmp(CompileFile, "") == 0)
				 StopNow = TRUE;
			  if (StopNow == TRUE)
				 MessageBox("Program Not Fully Configured.  Please Adjust Settings Or Import A SendBid 1.0 File If You Have SendBid 1.0 For DOS.", "Settings Error");
			  else
				 Translate();
			  break;
			}
			case '2' :
			{
			  Configure();
			  break;
			}
			case '3' :
			{
			  MessageBox("This program was created and translated to DOS by Steven Lawrance.  The pictures and icons (in the Windows version) were created by Joey Lawrance.  If you have any questions, fell free to contact me at \"steven.lawrance@contrail.com\".  Brought to you by KittyCat! Systems as FREEWARE.  Also be sure to watch for KittyCat! Comm 1.0 for Windows in 1995!  Thank you!", "About");
			  getch();
			  printf("\n");
			  break;
			}
			case '4' :
			{
			  printf("Bye!  Have a day filled with joy, sunshine, and happy thoughts!\n\n");
			  ExitYN = TRUE;
			  break;
			}
		 }
	  } while (ExitYN == FALSE);
	}
}

void Configure(void)
{
  int ExitConfigure = FALSE;
  do
  {
	 char Choice;
	 clrscr();
	 printf("-[Configuration]-\n1. Input File\n2. Output File\n3. Compile Flag\n4. Compiler\n5. Exit Configuration\n\nChoice: ");
	 do
	 {
		Choice = getch();
	 } while (((Choice < '1') || (Choice > '5')) && (Choice != 27));
	 if (Choice == 27)
		Choice = '5';
	 printf("%c\n", Choice);
	 switch (Choice)
	 {
		case '1' :
		{
		  strcpy(InputFile, GetFile("Input File", InputFile, "Text Files\0*.txt;*.wri;*.wps;*.doc\0All Files\0*.*\0\0", TRUE));
		  WritePrivateProfileString("FilePaths", "InputFile", InputFile, "BIDS.INI");
		  break;
		}
		case '2' :
		{
		  strcpy(OutputFile, GetFile("Output File", OutputFile, "ASP Files\0*.asp\0Text Files\0*.txt;*.wri;*.wps;*.doc\0All Files\0*.*\0\0", FALSE));
		  WritePrivateProfileString("FilePaths", "OutputFile", OutputFile, "BIDS.INI");
		  break;
		}
		case '3' :
		{
		  char Key;
		  printf("The current setting is to ");
		  if (CompileYN == FALSE)
			 printf("not ");
		  printf("compile.  Do you want to change it [Y/N]? ");
		  Key = getch();
		  while ((Key != 'y') && (Key != 'Y') && (Key != 'n') && (Key != 'N'))
		  {
			 sound(600);
			 delay(100);
			 nosound();
			 Key = getch();
		  }
		  if (((Key == 'Y') || (Key == 'y')) && (CompileYN == TRUE))
		  {
			 CompileYN = FALSE;
			 WritePrivateProfileString("Compile", "CompileYN", "FALSE", "BIDS.INI");
		  }
		  if (((Key == 'Y') || (Key == 'y')) && (CompileYN == FALSE))
		  {
			 CompileYN = TRUE;
			 WritePrivateProfileString("Compile", "CompileYN", "TRUE", "BIDS.INI");
		  }
		  break;
		}
		case '4' :
		{
		  strcpy(CompileFile, GetFile("Compiler Program", CompileFile, "Procomm Plus Compiler\0aspcomp.exe\0Executables\0*.exe;*.pif;*.com\0All Files\0*.*\0\0", TRUE));
		  WritePrivateProfileString("Compile", "CompileFile", CompileFile, "BIDS.INI");
		  break;
		}
		case '5' :
		{
		  ExitConfigure = TRUE;
		  break;
		}
	 }
  } while (ExitConfigure == FALSE);
}

#pragma argsused
char *GetFile(char *DialogText, char *DefaultText, char *FileString, int MustExist)
{
  char NewFile[288];
  FILE *FileExist;
  int ExitNow = FALSE;
  do
  {
	 char Typed;
	 int NumChars = strlen(DefaultText);
	 clrscr();
	 printf("-[%s]-\n", DialogText);
	 printf("File Name: %s", DefaultText);
	 memset(NewFile, NULL, 288);
	 strncpy(NewFile, DefaultText, 288);
	 Typed = getch();
	 while ((Typed != 13) && (Typed != 27))
	 {
		if ((((Typed >= 'a') && (Typed <= 'z')) || ((Typed >= 'A') && (Typed <= 'a')) || (Typed == ':') || (Typed == '_') || (Typed == '\\') || (Typed == '!') || (Typed == '.')) && (NumChars < 288))
		{
		  NewFile[NumChars] = Typed;
		  NumChars++;
		  printf("%c", Typed);
		}
		if (Typed == 8)
		{
		  if (NumChars < 288)
			 NewFile[NumChars] = '\0';
		  NumChars--;
		  printf("%c %c", 8, 8);
		}
		Typed = getch();
	 }
	 if (Typed == 27)
	 {
		memset(NewFile, NULL, 288);
		strncpy(NewFile, DefaultText, 288);
		ExitNow = TRUE;
	 }
	 FileExist = fopen(NewFile, "r");
  } while ((FileExist == NULL) && (MustExist == TRUE) && (ExitNow == FALSE));
  if (FileExist != NULL)
	 fclose(FileExist);
  printf("\n");
  return NewFile;
}

char *ReadToEndOfLine(FILE *hFile)
{
  char DataTmp[5];
  char WorkStr[300];
  long int ReadRes;
  int i = 0;
  memset(WorkStr, NULL, sizeof(WorkStr));
  memset(DataTmp, NULL, sizeof(DataTmp));
  ReadRes = _lread(hFile, DataTmp, 1);
  do
  {
	 if (ReadRes < 1)
	 {
		strcpy(WorkStr, "  [File Error: The Requested Segment Extends Out Of File!]  ");
		goto End;
	 }
	 WorkStr[i] = DataTmp[0];
	 ReadRes = _lread(hFile, DataTmp, 1);
	 i = i + 1;
  } while (DataTmp[0] != '\n');
  WorkStr[i] = '\0';
  End:
  return WorkStr;
}

void Translate(void)
{
  hInFile = fopen(InputFile, "r");
  hOutFile = fopen(OutputFile, "w");
  if ((hInFile == NULL) || (hOutFile == NULL))
  {
	 fclose(hInFile);
	 fclose(hOutFile);
	 MessageBox("Check File Names And Access Levels Before Trying Again.", "File Error");
  }
  else
  {
	 long int ReadTo;
	 char InText[100];
	 char DataTmp[2];
	 StatusLine("Writing Header To File...", "This puts a header on the ASP.");
	 WriteToFile(hOutFile, "PROC MAIN\n");
	 WriteToFile(hOutFile, "TRANSMIT \"5^M\"\n");
	 WriteToFile(hOutFile, "WAITFOR \"FOS >\"\n");
	 ReadTo = _lread(hInFile, DataTmp, 1);
	 _llseek(hInFile, -1, 1);
	 StatusLine("Converting File...", "This converts input to ASP.");
	 do
	 {
		if (ReadTo < 1)
		{
		  StatusLine("Adding footer to output file...", "This is the last step.");
		  WriteToFile(hOutFile, "TRANSMIT \"X^M\"\n");
		  WriteToFile(hOutFile, "WAITFOR \"FOS\"\n");
		  WriteToFile(hOutFile, "TRANSMIT \"9^M\"\n");
		  WriteToFile(hOutFile, "WAITFOR \"FOS >\"\n");
		  WriteToFile(hOutFile, "TRANSMIT \"C\"\n");
		  WriteToFile(hOutFile, "ENDPROC\n");
		  fclose(hOutFile);
		  fclose(hInFile);
		  if (CompileYN == TRUE)
		  {
			 char CompStr[288];
			 StatusLine("Compiling...", "This procedure only runs DOS compilers!");
			 strcpy(CompStr, CompileFile);
			 strcat(CompStr, " ");
			 strcat(CompStr, OutputFile);
			 execl(CompStr, NULL);
		  }
		  StatusLine("Finished!", "Exiting this window.");
		  DataTmp[0] = '!';
		}
		else
		{
		  strcpy(InText, "TRANSMIT \"");
		  strcat(InText, ReadToEndOfLine(hInFile));
		  strcat(InText, "^M\"\n");
		  WriteToFile(hOutFile, InText);
		  WriteToFile(hOutFile, "WAITFOR \"FOS >\"\n");
		  ReadTo = _lread(hInFile, DataTmp, 1);
		  _llseek(hInFile, -1, 1);
		}
		if (kbhit() != 0)
		{
		  char Key = '\0';
		  StatusLine("Processed Paused", "Do you want to continue [Y/N]?");
		  Key = getch();
		  while ((Key != 'y') && (Key != 'Y') && (Key != 'n') && (Key != 'N'))
		  {
			 sound(600);
			 delay(100);
			 nosound();
			 Key = getch();
		  }
		  if ((Key == 'Y') || (Key == 'y'))
			 StatusLine("Resuming...", "Resuming previous action before pause.");
		  else
		  {
			 fclose(hInFile);
			 fclose(hOutFile);
			 DataTmp[0] = '!';
		  }
		}
	 } while (DataTmp[0] != '!');
  }
}

void WriteToFile(FILE *hFile, char *Text)
{
  fputs(Text, hFile);
}

void StatusLine(char *Information, char *Percent)
{
  clrscr();
  printf("-[%s]-\n%s\n", Information, Percent);
}

void GetPrivateProfileString(const char *Section, const char *Item, const char *Default, char *Value, const int ValueLen, const char *FileName)
{
  FILE *IniFile;
  IniFile = fopen(FileName, "r");
  memset(Value, NULL, ValueLen);
  if (IniFile == NULL)
	 strncpy(Value, Default, ValueLen);
  else
  {
	 char NewSection[100];
	 int Found = FALSE;
	 memset(NewSection, NULL, 100);
	 NewSection[0] = '[';
	 strcat(NewSection, Section);
	 strcat(NewSection, "]");
	 while ((eof(fileno(IniFile)) == 0) && (Found == FALSE))
	 {
		if (strcmp(NewSection, ReadToEndOfLine(IniFile)) == 0)
		  Found = TRUE;
	 }
	 if (Found == TRUE)
	 {
		char Line[190];
		Found = FALSE;
		do
		{
		  memset(Line, NULL, 190);
		  strncpy(Line, ReadToEndOfLine(IniFile), 190);
		  if ((Line[0] != '[') && (Line[0] != '\0') && (strncmp(Line, Item, strlen(Item)-1) == 0))
		  {
			 int LinePos, ValuePos = 0;
			 for (LinePos = strlen(Item); (LinePos <= strlen(Line) - 1) && (LinePos <= ValuePos); LinePos++, ValuePos++)
				Value[ValuePos] = Line[LinePos];
			 Found = TRUE;
		  }
		} while ((eof(fileno(IniFile)) == 0) && (Found == FALSE) && (Line[0] != '['));
		if (Found == FALSE)
		  strncpy(Value, Default, ValueLen);
	 }
	 else
		strncpy(Value, Default, ValueLen);
	 fclose(IniFile);
  }
}

long int _llseek(FILE *hFile, long int Bytes, int Position)
{
  fseek(hFile, Bytes, Position);
  return ftell(hFile);
}

long int _lread(FILE *hFile, void *Data, long int Bytes)
{
  long int BeginPos = ftell(hFile);
  fread(Data, (size_t) Bytes, (size_t) 1, hFile);
  return (ftell(hFile) - BeginPos);
}

void MessageBox(char *Message, char *Title)
{
  clrscr();
  printf("-[%s]-\n%s\nPress any key to continue... ", Title, Message);
  do {} while (kbhit == 0);
}

void WritePrivateProfileString(const char *Section, const char *Item, const char *Value, const char *FileName)
{
  FILE *IniFile;
  char NewValue[288];
  memset(NewValue, NULL, 288);
  IniFile = fopen(FileName, "r+");
  if (IniFile == NULL)
	 IniFile = fopen(FileName, "w+");
  if (IniFile != NULL)
  {
	 char NewSection[100];
	 int Found = FALSE;
	 long int ItemLocation = -1;
	 Found = FALSE;
	 memset(NewSection, NULL, 100);
	 NewSection[0] = '[';
	 strcat(NewSection, Section);
	 strcat(NewSection, "]");
	 while ((eof(fileno(IniFile)) == 0) && (Found == FALSE))
	 {
		if (strcmp(NewSection, ReadToEndOfLine(IniFile)) == 0)
		  Found = TRUE;
	 }
	 if (Found == TRUE)
	 {
		char Line[190];
		do
		{
		  memset(Line, NULL, 190);
		  ItemLocation = ftell(IniFile);
		  strncpy(Line, ReadToEndOfLine(IniFile), 190);
		  if ((Line[0] != '[') && (Line[0] != '\0') && (strncmp(Line, Item, strlen(Item)-1) == 0))
		  {
			 int LinePos, ValuePos = 0;
			 for (LinePos = strlen(Item) + 1; (LinePos <= strlen(Line) - 1) && (LinePos <= ValuePos); LinePos++, ValuePos++)
				NewValue[ValuePos] = Line[LinePos];
			 Found = TRUE;
		  }
		} while ((eof(fileno(IniFile)) == 0) && (Found == FALSE) && (Line[0] != '['));
	 }
	 else
	 {
		fseek(IniFile, 0, 2);
		fprintf(IniFile, "[%s]\n\r", Section);
	 }
	 if ((Found == TRUE) && (strlen(Value) == strlen(NewValue)))
	 {
		fseek(IniFile, ItemLocation, 0);
		fprintf(IniFile, "%s=%s\n\r", Item, Value);
	 }
	 if ((Found == TRUE) && (strlen(Value) != strlen(NewValue)))
	 {
		FILE *TmpFile;
		TmpFile = fopen("~bid2asp.tmp", "w+");
		if (TmpFile == NULL)
		  MessageBox("Cannot create temporary file!", "Internal Error");
		else
		{
		  while (eof(fileno(IniFile)) == 0)
			 fprintf(TmpFile, "%s", ReadToEndOfLine(IniFile));
		  fseek(IniFile, ItemLocation, 0);
		  fseek(TmpFile, 0, 0);
		  fprintf(IniFile, "%s=%s\n\r", Item, Value);
		  while (eof(fileno(IniFile)) == 0)
			 fprintf(IniFile, "%s", ReadToEndOfLine(TmpFile));
		  fclose(TmpFile);
		  unlink("~bid2asp.tmp");
		}
	 }
	 if (Found == FALSE)
	 {
		fseek(IniFile, 0, 2);
		fprintf(IniFile, "%s=%s\n\r", Item, Value);
	 }
	 fclose(IniFile);
  }
}

